/**
 * My Title
 * No description provided (generated by Swagger Codegen https://github.com/swagger-api/swagger-codegen)
 *
 * OpenAPI spec version: 1.0.0
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */
package io.swagger.client.apis

import io.swagger.client.models.GetProjectUsersRequest
import io.swagger.client.models.ProjectInfo
import io.swagger.client.models.ProjectUserSummary
import io.swagger.client.models.UserInviteRequest

import io.swagger.client.infrastructure.*

class ProjectsServiceApi(basePath: kotlin.String = "http://localhost:8080") : ApiClient(basePath) {

    /**
     * 
     * 
     * @param body  
     * @return ProjectInfo
     */
    @Suppress("UNCHECKED_CAST")
    fun projectsServiceCreateProject(body: kotlin.String): ProjectInfo {
        val localVariableBody: kotlin.Any? = body
        val localVariableConfig = RequestConfig(
                RequestMethod.POST,
                "/api/project/create"
        )
        val response = request<ProjectInfo>(
                localVariableConfig, localVariableBody
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as ProjectInfo
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * 
     * 
     * @param id  
     * @return ProjectInfo
     */
    @Suppress("UNCHECKED_CAST")
    fun projectsServiceGetById(id: kotlin.String): ProjectInfo {
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/api/project/{id}".replace("{" + "id" + "}", "$id")
        )
        val response = request<ProjectInfo>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as ProjectInfo
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * 
     * 
     * @param body  
     * @return kotlin.Array<ProjectUserSummary>
     */
    @Suppress("UNCHECKED_CAST")
    fun projectsServiceGetProjectUsers(body: GetProjectUsersRequest): kotlin.Array<ProjectUserSummary> {
        val localVariableBody: kotlin.Any? = body
        val localVariableConfig = RequestConfig(
                RequestMethod.POST,
                "/api/project/users"
        )
        val response = request<kotlin.Array<ProjectUserSummary>>(
                localVariableConfig, localVariableBody
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<ProjectUserSummary>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * 
     * 
     * @return kotlin.Array<ProjectInfo>
     */
    @Suppress("UNCHECKED_CAST")
    fun projectsServiceGetProjectsList(): kotlin.Array<ProjectInfo> {
        val localVariableConfig = RequestConfig(
                RequestMethod.GET,
                "/api/project/all"
        )
        val response = request<kotlin.Array<ProjectInfo>>(
                localVariableConfig
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Array<ProjectInfo>
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * 
     * 
     * @param body  
     * @return kotlin.Boolean
     */
    @Suppress("UNCHECKED_CAST")
    fun projectsServiceInviteUserToProject(body: UserInviteRequest): kotlin.Boolean {
        val localVariableBody: kotlin.Any? = body
        val localVariableConfig = RequestConfig(
                RequestMethod.POST,
                "/api/project/invite"
        )
        val response = request<kotlin.Boolean>(
                localVariableConfig, localVariableBody
        )

        return when (response.responseType) {
            ResponseType.Success -> (response as Success<*>).data as kotlin.Boolean
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
    /**
     * 
     * 
     * @param contentType  (optional)
     * @param contentDisposition  (optional)
     * @param headers  (optional)
     * @param length  (optional)
     * @param name  (optional)
     * @param fileName  (optional)
     * @param projectId  (optional)
     * @return void
     */
    fun projectsServiceUpdateProjectPic(contentType: kotlin.String? = null, contentDisposition: kotlin.String? = null, headers: kotlin.Array<kotlin.Any>? = null, length: kotlin.Long? = null, name: kotlin.String? = null, fileName: kotlin.String? = null, projectId: kotlin.String? = null): Unit {
        val localVariableBody: kotlin.Any? = mapOf("ContentType" to "$contentType", "ContentDisposition" to "$contentDisposition", "Headers" to "$headers", "Length" to "$length", "Name" to "$name", "FileName" to "$fileName")
        val localVariableQuery: MultiValueMap = mutableMapOf<kotlin.String, kotlin.collections.List<kotlin.String>>().apply {
            if (projectId != null) {
                put("projectId", listOf(projectId.toString()))
            }
        }
        val localVariableHeaders: MutableMap<String, String> = mutableMapOf("Content-Type" to "multipart/form-data")
        
        val localVariableConfig = RequestConfig(
                RequestMethod.POST,
                "/api/project/picture", query = localVariableQuery, headers = localVariableHeaders
        )
        val response = request<Any?>(
                localVariableConfig, localVariableBody
        )

        return when (response.responseType) {
            ResponseType.Success -> Unit
            ResponseType.Informational -> TODO()
            ResponseType.Redirection -> TODO()
            ResponseType.ClientError -> throw ClientException((response as ClientError<*>).body as? String ?: "Client error")
            ResponseType.ServerError -> throw ServerException((response as ServerError<*>).message ?: "Server error")
        }
    }
}
